我正在尝试使用md5sumbash脚本中比较两个文件。

目的是使用一个文件的.md5来检查另一文件的md5sum。我的Google搜索如何正确执行此操作并没有向我显示我如何执行此操作。开除电子邮件的方法符合您的预期。现在,我试图使它针对失败而不是成功发出电子邮件。

也许列出从.md5文件接收到的结果以及损坏文件的实际md5sum。最终,我会弄清楚这一点,但这有点令人困惑,因为我试图弄清楚我在哪里出问题了。

Shellcheck指示代码看起来不错,但是我没有得到期望得到的结果。

我检查了一些StackOverflow链接,看是否可以解决问题:

One

Two

这是我的bash脚本的原始形式的内容:

#!/bin/bash
cd /home/example/public_html/exampledomain.com/billing/system/ || exit
rm -rf GeoLiteCity.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz | gunzip > GeoLiteCity.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.mmdb.gz | gunzip > GeoLite2-City.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.md5
md5sum GeoLite2-City.dat > md5sum.txt

file1="md5sum.txt"
file2="GeoLite2-City.md5"

if [ "`cat $file1`" != "`cat $file2`" ]; then
mail -s "Results of GeoLite Updates" [email protected] <<< "md5sum for GeoLite2-City failed. Please check the md5sum. File may possibly be corrupted."
else
exit
fi

编辑:

将代码更新为以下内容:
#!/bin/bash
cd /home/example/web/exampledomain/public_html/billing/system/ || exit
rm -rf GeoLite*
rm -rf md5sum.txt
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz | gunzip > GeoLiteCity.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.mmdb.gz | gunzip > GeoLite2-City.dat
wget https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.md5
md5sum GeoLite2-City.dat > md5sum.txt

file1="md5sum.txt"
file2="GeoLite2-City.md5"

if ! cmp "$file1" "$file2"; then echo "They don't match."; fi

仍在努力。接近使它真正起作用!

以上结果:
root@example# cat GeoLite2-City.md5
e8c076d6ff83e9a615aedc7d5d1842d7
root@example# md5sum GeoLite2-City.dat
e8c076d6ff83e9a615aedc7d5d1842d7  GeoLite2-City.dat
root@example# cat md5sum.txt
e8c076d6ff83e9a615aedc7d5d1842d7  GeoLite2-City.dat

Edit2:代码现在也如下所示,请注意,我删除了GeoLiteCity2和GeoLite,以便每次MaxMind更新数据库时都重新下载数据库:
#!/bin/bash

# cd to directory where the MaxMind database is to be downloaded.
if ! cd /home/example/public_html/billing/system/; then
echo "Can't find work directory" >&2
exit 1
fi

# Remove existing files so we start off with a clean set of updated data from Maxmind.

rm -f GeoLite*
rm -f md5sum.txt

# Download databases and if applicable, their md5s.

curl -L https://geolite.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz | gunzip > GeoLiteCity.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.mmdb.gz | gunzip > GeoLite2-City.dat
curl -O https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.md5

# Create md5sum of the GeoLite2 database.
md5sum < GeoLite2-City.dat > md5sum.txt
# Strip out the spurious - seen in md5sum.txt
sed -i 's/ .*//' md5sum.txt

# Set what files are what for file comparison purposes.
file1="md5sum.txt"
file2="GeoLite2-City.md5"

# DO THE THING! ie, compare!
if ! cmp --silent "$file1" "$file2"; then
mail -s "Results of GeoLite Updates" [email protected] <<< "md5sum for GeoLite2-City failed. Please check the md5sum. File may possibly be corrupted."
fi

最佳答案

因此,..您遇到的问题似乎是您创建的md5sum.txt文件的格式与您下载的.md5文件的格式不匹配,您需要针对该格式检查计算的值。

以下内容将更接近我的脚本版本。 (下面的说明。)

#!/bin/bash

if ! cd /home/example/public_html/exampledomain.com/billing/system/; then
  echo "Can't find work directory" >&2
  exit 1
fi

rm -f GeoLiteCity.dat

curl -L https://geolite.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz | gunzip > GeoLiteCity.dat
curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.mmdb.gz | gunzip > GeoLite2-City.dat
curl -O https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.md5
md5sum < GeoLite2-City.dat | cut -d\  -f1 > md5sum.txt

file1="md5sum.txt"
file2="GeoLite2-City.md5"

if ! cmp --silent "$file1" "$file2"; then
  mail -s "Results of GeoLite Updates" [email protected] <<< "md5sum for GeoLite2-City failed. Please check the md5sum. File may possibly be corrupted."
fi

这里的主要区别是..
  • rm -f GeoLightCity.dat而不是-rf。让我们不要超出需要的范围。
  • md5sum接受标准输入,而不是按名称处理文件。结果是输出不包含文件名。不幸的是,由于Linux md5sum命令的限制,它仍然与您从Maxmind下载的.md5文件不匹配,因此:
  • cut用于修改结果输出,仅保留计算出的md5。
  • 根据您对问题的评论,使用cmp而不是子shell的

  • 第二点和第三点也许对您来说是最重要的。

    创建md5sum.txt文件的另一种选择是在下载时即时进行。例如:
    curl -L https://geolite.maxmind.com/download/geoip/database/GeoLite2-City.mmdb.gz \
    | gunzip | tee -a GeoLite2-City.dat | cut -d\  -f1 | md5sum > md5sum.txt
    

    这使用tee命令将文件拆分到其“保存”位置和另一个管道,该管道通过md5sum生成您的.txt文件。

    可能会节省您一分钟的时间,否则它将被之后运行的md5sum吞噬。而且它将更好地利用SMP。 :)

    关于linux - 比较bash脚本中的md5总和,我们在Stack Overflow上找到一个类似的问题:https://stackoverflow.com/questions/33049634/

    10-09 18:53